CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  SUBROUTINE TO CALCULATE THE RATE COEFFICIENTS (K)  C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE RATES(RADIUS)
      DOUBLE PRECISION Y(1000),K(10000),ALF(10000,5),BET(10000,5),
     *   GAM(10000,5),TLOWER(10000,5),TUPPER(10000,5),TOTAL(10),X(10),
     *   RAD,AUV,H2COL,TEMP,ZETA,ALBEDO,GAMCO,ACCR,HNR,X_G,A_G,MLOSS,V,
     *   RADIUS,PI,MH,MU,KB,DTMIN,DT,AUV_AV
      DOUBLE PRECISION GETHNR,GETTEM,GETH2,GETAUV,GETRAD,GETCOR,EARG
      INTEGER RTYPE(10000),NTR(10000),NREAC,ICO,ICOR,TR,I,J
      COMMON/BL1/ K,X,TOTAL,ACCR,HNR
      COMMON/BL2/ MLOSS,V
      COMMON/BL3/ Y,X_G,A_G,ZETA,ALBEDO,GAMCO,AUV_AV,ICO
      COMMON/BL4/ ALF,BET,GAM,TLOWER,TUPPER,RTYPE,NTR,NREAC,ICOR
      COMMON/BLC/ PI,MH,MU,KB

C  H2 NUMBER DENSITY
      HNR = GETHNR(RADIUS)
C  TEMPERATURE
      TEMP = GETTEM(RADIUS)
C  H2 COLUMN DENSITY
      H2COL = GETH2(RADIUS,HNR)
C  RADIAL UV EXTINCTION
      AUV = GETAUV(H2COL)
C  RADIATION FIELD STRENGTH
      RAD = GETRAD(AUV)

C  H-ATOM ACCRETION RATE
      ACCR = 0.3*PI*(A_G**2.0)*HNR*X_G*(8.0*KB*TEMP/(PI*MH))**0.5


C  *****CALCULATE REACTION RATES****************************************

      DO J=1,NREAC

C  DETERMINE TEMPERATURE RANGE FOR RATE COEFFICIENTS

C  INITIALISE TEMPERATURE RANGE INDEX
         TR = 1
C  IF MULTIPLE TEMP RANGES, FIND THE CLOSEST MATCH TO CURRENT TEMP.
         IF(NTR(J).GT.1) THEN
            DTMIN = 1.0E20
            DO I = 1,NTR(J)
               IF(TEMP.GE.TLOWER(J,I).AND.TEMP.LT.TUPPER(J,I)) THEN
                  TR = I
                  GO TO 201
               ELSE
                  DT = ABS(TLOWER(J,I)-TEMP)
                  IF(ABS(TUPPER(J,I)-TEMP).LT.DT) THEN
                     DT = ABS(TUPPER(J,I)-TEMP)
                  END IF
                  IF(DT.LT.DTMIN) THEN
                     DTMIN = DT
                     TR = I
                  END IF
               END IF
            END DO
         END IF


C  COMPUTE RATE COEFFICIENTS BASED ON REACTION TYPE

C  COSMIC RAY PARTICLE RATE
 201  IF(RTYPE(J).EQ.1) THEN
      K(J) = ALF(J,TR)*ZETA

C  COSMIC RAY PHOTO-RATE
      ELSE IF(RTYPE(J).EQ.2) THEN
      K(J) = ZETA*ALF(J,TR)*((TEMP/300.0)**BET(J,TR))*GAM(J,TR)
     *   /(1.0-ALBEDO)

C  PHOTO-REACTION RATE 
      ELSE IF(RTYPE(J).EQ.3) THEN
      K(J) = RAD*ALF(J,TR)*EARG((GAMCO-GAM(J,TR))*(AUV/AUV_AV))

C  DEFAULT BINARY REACTION RATE
      ELSE
      K(J) = ALF(J,TR)*((TEMP/300.0)**BET(J,TR))*EARG(-GAM(J,TR)/TEMP)
      END IF

C 210  PRINT*,"K (",J,") = ",K(J),ALF(J,TR),BET(J,TR),GAM(J,TR)
      END DO

C  SET CO PHOTODISSOCIATION RATE
      K(ICOR) = GETCOR(H2COL,Y(ICO),V,AUV)

      RETURN
      END
